Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 14744)
@@ -10,13 +10,15 @@
   /// <typeparam name="T">Stacktype</typeparam>
   public abstract class YankExpression<T> : StatelessExpression {
-    public void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1) {
-      if (integerStack.Count == 0) return;
+    public bool Eval(IStack<T> stack, IStack<long> integerStack, int count = 1) {
+      if (integerStack.Count == 0) return false;
 
       var index = integerStack.Top;
 
-      if ((index > stack.Count - count) || (index < 0) || (stack.Count < 2)) return;
+      if ((index > stack.Count - count) || (index < 0) || (stack.Count < 2)) return false;
 
       integerStack.Pop();
       stack.Yank((int)index);
+
+      return true;
     }
   }
@@ -24,6 +26,6 @@
   [PushExpression(StackType.Integer, "INTEGER.YANK")]
   public class IntegerYankExpression : YankExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
     }
   }
@@ -31,6 +33,6 @@
   [PushExpression(StackType.Float, "FLOAT.YANK")]
   public class FloatYankExpression : YankExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
     }
   }
@@ -38,6 +40,6 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.YANK")]
   public class BooleanYankExpression : YankExpression<bool> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
     }
   }
@@ -45,6 +47,6 @@
   [PushExpression(StackType.Name, "NAME.YANK")]
   public class NameYankExpression : YankExpression<string> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.NameStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.NameStack, interpreter.IntegerStack);
     }
   }
@@ -52,6 +54,6 @@
   [PushExpression(StackType.Exec, "EXEC.YANK")]
   public class ExecYankExpression : YankExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
     }
   }
@@ -59,6 +61,6 @@
   [PushExpression(StackType.Code, "CODE.YANK")]
   public class CodeYankExpression : YankExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator.cs	(revision 14744)
@@ -6,5 +6,4 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Random;
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 14744)
@@ -0,0 +1,44 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter {
+  using System.Collections.Generic;
+  using System.Threading;
+  using System.Threading.Tasks;
+  using Core;
+  using Expressions;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+
+  using Stack;
+
+  public interface IPushInterpreter {
+    IRandom Random { get; set; }
+
+    IStack<Expression> CodeStack { get; }
+    IStack<Expression> ExecStack { get; }
+    IStack<string> NameStack { get; }
+    IStack<bool> BooleanStack { get; }
+    IStack<long> IntegerStack { get; }
+    IStack<double> FloatStack { get; }
+
+    IDictionary<string, Expression> CustomExpressions { get; }
+
+    IReadonlyPushConfiguration Configuration { get; }
+
+    bool IsNameQuoteFlagSet { get; set; }
+
+    void Clear();
+    void Run(string code, bool stepwise = false);
+    void Run(Expression program, bool stepwise = false);
+    void Run(PushProgram program, bool stepwise = false);
+    Task RunAsync(PushProgram program, bool paused = false, CancellationToken token = default(CancellationToken));
+    Task RunAsync(Expression program, bool paused = false, CancellationToken token = default(CancellationToken));
+    Task RunAsync(string code, bool paused = false, CancellationToken token = default(CancellationToken));
+    Task AbortAndResetAsync();
+    Task AbortAsync();
+    Task PauseAsync();
+    void Resume();
+    Task ResumeAsync();
+
+    bool Step();
+    void PrintStacks();
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PooledPushInterpreter.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PooledPushInterpreter.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PooledPushInterpreter.cs	(revision 14744)
@@ -0,0 +1,22 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter {
+  using System;
+
+  using HeuristicLab.Core;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+
+  public class PooledPushInterpreter : PushInterpreter, IDisposable {
+
+    private readonly PushInterpreterPool pool;
+
+    public PooledPushInterpreter(PushInterpreterPool pool, PushConfiguration config, IRandom random = null)
+      : base(config, random) {
+      this.pool = pool;
+    }
+
+    public void Dispose() {
+      this.Reset();
+      this.Configuration = this.Configuration;
+      this.pool.Free(this);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 14744)
@@ -0,0 +1,283 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter {
+  using System;
+  using System.Collections.Generic;
+  using System.Runtime.CompilerServices;
+  using System.Threading;
+  using System.Threading.Tasks;
+  using HeuristicLab.Core;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+  using HeuristicLab.Random;
+
+  public class PushInterpreter : IPushInterpreter {
+    private Task currentTask;
+
+    public PushInterpreter(IReadonlyPushConfiguration config = null, IRandom random = null) {
+      Random = random ?? new FastRandom();
+
+      Configuration = config ?? new PushConfiguration();
+
+      // setting the capacity of the stacks to max points ensures that there will be enough memory at runtime
+      ExecStack = new PushStack<Expression>(Configuration.EvalPushLimit);
+
+      CodeStack = new PushStack<Expression>(Configuration.EvalPushLimit) {
+        IsEnabled = Configuration.IsCodeStackEnabled
+      };
+
+      NameStack = new PushStack<string> {
+        IsEnabled = Configuration.IsNameStackEnabled
+      };
+      BooleanStack = new PushStack<bool> {
+        IsEnabled = Configuration.IsBooleanStackEnabled
+      };
+      IntegerStack = new PushStack<long> {
+        IsEnabled = Configuration.IsIntegerStackEnabled
+      };
+      FloatStack = new PushStack<double> {
+        IsEnabled = Configuration.IsFloatStackEnabled
+      };
+
+      CustomExpressions = new Dictionary<string, Expression>();
+    }
+
+    public PushInterpreter(int seed, IReadonlyPushConfiguration config = null)
+      : this(config, new FastRandom(seed)) {
+    }
+
+    public IRandom Random { get; set; }
+
+    public int ExecCounter { get; private set; }
+
+    public bool IsPaused { get; private set; }
+
+    public bool IsAborted { get; private set; }
+
+    public bool IsRunning
+    {
+      get
+      {
+        return !ExecStack.IsEmpty &&
+               !IsPaused &&
+               !IsAborted &&
+               (ExecCounter < Configuration.EvalPushLimit);
+      }
+    }
+
+    public bool IsCompleted
+    {
+      get
+      {
+        return ExecStack.Count == 0;
+      }
+    }
+
+    public bool CanStep
+    {
+      get
+      {
+        return !IsCompleted && !IsAborted && IsPaused;
+      }
+    }
+
+    public IReadonlyPushConfiguration Configuration { get; protected set; }
+
+    public IStack<Expression> CodeStack { get; private set; }
+
+    public IStack<Expression> ExecStack { get; private set; }
+
+    public IStack<string> NameStack { get; private set; }
+
+    public IStack<bool> BooleanStack { get; private set; }
+
+    public IStack<long> IntegerStack { get; private set; }
+
+    public IStack<double> FloatStack { get; private set; }
+
+    public IDictionary<string, Expression> CustomExpressions { get; private set; }
+
+    public bool IsNameQuoteFlagSet { get; set; }
+
+    public void Run(string code, bool stepwise = false) {
+      var program = PushParser.Parse(code);
+      Run(program, stepwise);
+    }
+
+    public Task RunAsync(string code, bool stepwise = false, CancellationToken token = default(CancellationToken)) {
+      var program = PushParser.Parse(code);
+
+      currentTask = RunAsync(program, stepwise, token);
+
+      return currentTask;
+    }
+
+    public async Task RunAsync(
+      PushProgram program,
+      bool stepwise = false,
+      CancellationToken token = default(CancellationToken)) {
+      var expression = new ExecExpandExpression(program);
+
+      await RunAsync(expression, stepwise, token);
+    }
+
+    public async Task RunAsync(
+      Expression program,
+      bool stepwise = false,
+      CancellationToken token = default(CancellationToken)) {
+      await Task.Run(() => Run(program, stepwise), token);
+    }
+
+    public void Run(PushProgram program, bool stepwise = false) {
+      var expression = new ExecExpandExpression(program);
+
+      Run(expression, stepwise);
+    }
+
+    public void Run(Expression program, bool stepwise = false) {
+      IsPaused = stepwise;
+
+      /* Push top expression so the loop is able to enter
+       * If the top expression is a single statement then the loop has nothing to do
+       * Otherwise the expand expression will be evaluated and pushes code onto the EXEC stack */
+      ExecStack.Push(program);
+
+      if (Configuration.TopLevelPushCode) CodeStack.Insert(0, program);
+
+      // run top expression
+      DoStep();
+
+      Interpret();
+    }
+
+    public async Task AbortAsync() {
+      if (IsAborted || IsCompleted) return;
+
+      IsAborted = true;
+
+      if (currentTask != null) await currentTask;
+    }
+
+    public async Task AbortAndResetAsync() {
+      await AbortAsync();
+      Reset();
+    }
+
+    public async Task PauseAsync() {
+      if (IsPaused || IsCompleted) return;
+
+      IsPaused = true;
+
+      if (currentTask != null) await currentTask;
+    }
+
+    public async Task ResumeAsync() {
+      if (IsPaused || !IsAborted) {
+        IsPaused = false;
+        await InterpretAsync();
+      } else await currentTask;
+    }
+
+    public void Resume() {
+      if (!IsPaused && IsAborted)
+        return;
+
+      IsPaused = false;
+      Interpret();
+    }
+
+    [MethodImpl(MethodImplOptions.AggressiveInlining)]
+    public bool Step() {
+      if (!CanStep) return false;
+
+      var successful = DoStep();
+      Finally();
+
+      return successful;
+    }
+
+    [MethodImpl(MethodImplOptions.AggressiveInlining)]
+    public void Step(int count) {
+      for (var i = 0; i < count; i++) Step();
+    }
+
+    public void PrintStacks() {
+      PrintStack("EXEC", ExecStack);
+      PrintStack("CODE", CodeStack);
+      PrintStack("NAME", NameStack);
+      PrintStack("BOOLEAN", BooleanStack);
+      PrintStack("FLOAT", FloatStack);
+      PrintStack("INTEGER", IntegerStack);
+
+      if (CustomExpressions.Count == 0) return;
+      Console.WriteLine("--------- Custom Expressions ---------");
+      foreach (var ce in CustomExpressions) {
+        Console.WriteLine("{0}: {1}", ce.Key, ce.Value);
+      }
+    }
+
+    /// <summary>
+    /// Clears stacks
+    /// </summary>
+    public void Reset() {
+      IsAborted = false;
+      IsPaused = false;
+      currentTask = null;
+
+      Clear();
+    }
+
+    /// <summary>
+    /// Clears stacks
+    /// </summary>
+    public void Clear() {
+      ExecCounter = 0;
+
+      ExecStack.Clear();
+      CodeStack.Clear();
+
+      NameStack.Clear();
+      BooleanStack.Clear();
+      IntegerStack.Clear();
+      FloatStack.Clear();
+
+      CustomExpressions.Clear();
+    }
+
+    [MethodImpl(MethodImplOptions.AggressiveInlining)]
+    private void Interpret() {
+      while (IsRunning) {
+        DoStep();
+        ExecCounter++;
+      }
+
+      Finally();
+    }
+
+    [MethodImpl(MethodImplOptions.AggressiveInlining)]
+    private void Finally() {
+      if (!IsCompleted)
+        return;
+
+      if (Configuration.TopLevelPopCode && (CodeStack.Count > 0))
+        CodeStack.Pop();
+    }
+
+    [MethodImpl(MethodImplOptions.AggressiveInlining)]
+    private bool DoStep() {
+      return ExecStack.Pop().Eval(this);
+    }
+
+    private Task InterpretAsync() {
+      currentTask = Task.Run(() => Interpret());
+
+      return currentTask;
+    }
+
+    private void PrintStack<T>(string name, IStack<T> stack) {
+      if (stack.IsEmpty) return;
+      Console.WriteLine("--------- {0} ---------\n{1}\n", name, stack);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 14744)
@@ -0,0 +1,35 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter {
+  using System;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
+  using HeuristicLab.Core;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Random;
+
+  public class PushInterpreterPool {
+    private readonly ObjectPool<PooledPushInterpreter> pool;
+
+    public PushInterpreterPool(PushConfiguration config = null)
+      : this(Environment.ProcessorCount * 2, config) {
+    }
+
+    public PushInterpreterPool(int size, PushConfiguration config = null) {
+      this.PushGpConfiguration = config ?? new PushConfiguration();
+
+      this.pool = new ObjectPool<PooledPushInterpreter>(() => new PooledPushInterpreter(this, this.PushGpConfiguration), size);
+    }
+
+    public PushConfiguration PushGpConfiguration { get; private set; }
+
+    public PooledPushInterpreter GetInstance(IRandom random = null) {
+      var interpreter = this.pool.Allocate();
+      interpreter.Random = random ?? new FastRandom();
+
+      return interpreter;
+    }
+
+    public void Free(PooledPushInterpreter interpreter) {
+      this.pool.Free(interpreter);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs	(revision 14744)
@@ -0,0 +1,92 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Parser {
+  using System.Collections.Generic;
+  using System.Globalization;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+
+  public static class PushParser {
+    private const string openBrace = "(";
+
+    private const string closeBrace = ")";
+
+    private const char delimiter = ' ';
+
+    private static readonly CultureInfo cultureInfo = CultureInfo.CreateSpecificCulture("en-US");
+
+    private static readonly char[] symbolTrim = { '\r', '\n' };
+
+    public static Expression Parse(string source, int startIndex = 0) {
+      var symbols = source.Split(delimiter);
+
+      int endIndex;
+      return Parse(symbols, 0, out endIndex);
+    }
+
+    private static Expression Parse(string[] symbols, int startIndex, out int endIndex) {
+      var expressions = new List<Expression>();
+
+      for (var i = startIndex; i < symbols.Length; i++) {
+        var symbol = symbols[i].TrimEnd(symbolTrim);
+
+        if (string.IsNullOrWhiteSpace(symbol)) continue;
+
+        switch (symbol) {
+          case openBrace:
+            var subExpression = Parse(symbols, i + 1, out endIndex);
+            expressions.Insert(0, subExpression);
+            i = endIndex;
+            continue;
+          case closeBrace:
+            endIndex = i;
+            return new ExecExpandExpression(expressions.ToArray());
+        }
+
+        // literal
+        Expression expression;
+        if (TryParseLiteral(symbol, out expression)) {
+          expressions.Insert(0, expression);
+          continue;
+        }
+
+        // expression
+        if (ExpressionTable.TryGetStatelessExpression(symbol, out expression)
+            || ExpressionTable.TryGetStatefullExpression(symbol, out expression)) {
+          expressions.Insert(0, expression);
+          continue;
+        }
+
+        // identifier - custom expression or named literals
+        expressions.Insert(0, new NameDefineXExecExpression(symbol));
+      }
+
+      endIndex = symbols.Length - 1;
+
+      return expressions.Count == 1
+        ? expressions[0]
+        : new ExecExpandExpression(expressions.ToArray());
+    }
+
+    private static bool TryParseLiteral(string word, out Expression expression) {
+      long longValue;
+      if (long.TryParse(word, out longValue)) {
+        expression = new IntegerPushExpression(longValue);
+        return true;
+      }
+
+      double floatValue;
+      if (double.TryParse(word, NumberStyles.Float, cultureInfo, out floatValue)) {
+        expression = new FloatPushExpression(floatValue);
+        return true;
+      }
+
+      bool booleanValue;
+      if (bool.TryParse(word, out booleanValue)) {
+        expression = new BooleanPushExpression(booleanValue);
+        return true;
+      }
+
+      expression = null;
+      return false;
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushEncoding.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushEncoding.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushEncoding.cs	(revision 14744)
@@ -37,14 +37,14 @@
 
   public static class IndividualExtensionMethods {
-    public static PushProgram PushProgram(this Individual individual, IList<string> enabledExpressions) {
-      return MapToProgram(individual.IntegerVector(), enabledExpressions);
+    public static PushProgram PushProgram(this Individual individual, IReadOnlyList<string> enabledExpressions) {
+      return individual.IntegerVector().MapToPushProgram(enabledExpressions);
     }
 
-    private static PushProgram MapToProgram(IntegerVector vector, IList<string> enabledExpressions) {
+    public static PushProgram MapToPushProgram(this IntegerVector vector, IReadOnlyList<string> enabledExpressions) {
       var expressions = vector
         .Select(i => ExpressionTable.GetExpression(enabledExpressions[i]))
         .ToArray();
 
-      return new PushProgram(expressions);
+      return new Expressions.PushProgram(expressions);
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 14744)
@@ -4,5 +4,4 @@
   using System.Collections.Generic;
   using System.Linq;
-  using BenchmarkSuite.Problems;
   using Common;
   using Configuration;
@@ -10,4 +9,6 @@
   using Encodings.IntegerVectorEncoding;
   using Expressions;
+
+  using HeuristicLab.BenchmarkSuite;
   using HeuristicLab.Data;
   using Instances;
@@ -21,5 +22,5 @@
   [Creatable(CreatableAttribute.Categories.GeneticProgrammingProblems, Priority = 180)]
   [Item("Push Problem", "")]
-  public class PushProblem : SingleObjectiveBasicProblem<IntegerVectorEncoding>, IProblemInstanceConsumer<Data> {
+  public class PushProblem : SingleObjectiveBasicProblem<IntegerVectorEncoding>, IProblemInstanceConsumer<IBenchmarkSuiteDataDescriptor> {
     [Storable]
     private readonly PushConfiguration config;
@@ -49,5 +50,4 @@
       this.InitEvents();
     }
-
 
     [StorableHook(HookType.AfterDeserialization)]
@@ -102,8 +102,8 @@
       var bounds = new IntMatrix(1, 3, new[] { "Training Start", "Training End | Test Start", "Test End" });
       bounds.ItemChanged += (s, e) => {
-        if (Data == null)
+        if (this.DataDescriptor == null)
           return;
 
-        var max = Data.OriginalTestCount + Data.OriginalTrainingCount - 1;
+        var max = this.DataDescriptor.OriginalTestCount + this.DataDescriptor.OriginalTrainingCount - 1;
         bounds[0, 0] = Math.Min(Math.Max(bounds[0, 0], 0), max);
         bounds[0, 2] = Math.Max(Math.Min(bounds[0, 2], max), 0);
@@ -174,5 +174,5 @@
         new IntValue(config.MaxPointsInRandomExpression)) { Hidden = true });
 
-      Parameters.Add(new ValueParameter<Data>(DataParameterName, DataParameterDescription));
+      Parameters.Add(new ValueParameter<IBenchmarkSuiteDataDescriptor>(DataParameterName, DataParameterDescription));
 
       Encoding.Bounds[0, 0] = 0;
@@ -204,10 +204,10 @@
     }
 
-    public IValueParameter<Data> DataParameter
-    {
-      get { return (IValueParameter<Data>)Parameters[DataParameterName]; }
-    }
-
-    public Data Data
+    public IValueParameter<IBenchmarkSuiteDataDescriptor> DataParameter
+    {
+      get { return (IValueParameter<IBenchmarkSuiteDataDescriptor>)Parameters[DataParameterName]; }
+    }
+
+    public IBenchmarkSuiteDataDescriptor DataDescriptor
     {
       get { return DataParameter.Value; }
@@ -394,6 +394,5 @@
       var bestIdx = Array.IndexOf(qualities, bestQuality);
       var bestIndividual = individuals[bestIdx];
-      var program = bestIndividual.PushProgram(config.EnabledExpressions);
-      var solution = new PushSolution(program, bestQuality, Data, random, pool);
+      var solution = new PushSolution(bestIndividual.IntegerVector(), bestQuality, DataDescriptor, random, config);
 
       if (!results.ContainsKey(bestSolutionResultName)) {
@@ -405,5 +404,6 @@
 
     public override double Evaluate(Individual individual, IRandom random) {
-      var program = individual.PushProgram(config.EnabledExpressions);
+
+      var program = individual.PushProgram(config.EnabledExpressions as IReadOnlyList<string>);
       var expandExpression = new ExecExpandExpression(program);
       var results = new List<double>();
@@ -411,5 +411,5 @@
       using (var interpreter = pool.GetInstance(random)) {
         for (var i = DataBounds[0, 0]; i < DataBounds[0, 1]; i++) {
-          var example = Data.Examples[i];
+          var example = this.DataDescriptor.Examples[i];
 
           interpreter.BooleanStack.Push(example.InputBoolean);
@@ -419,7 +419,7 @@
           interpreter.Run(expandExpression);
 
-          var diff = GetDiff(example.OutputInt, interpreter.IntegerStack, Data.WorstResult, LongDiffer) +
-                     GetDiff(example.OutputFloat, interpreter.FloatStack, Data.WorstResult, DoubleDiffer) +
-                     GetDiff(example.OutputBoolean, interpreter.BooleanStack, Data.WorstResult, BooleanDiffer);
+          var diff = GetDiff(example.OutputInt, interpreter.IntegerStack, this.DataDescriptor.WorstResult, LongDiffer) +
+                     GetDiff(example.OutputFloat, interpreter.FloatStack, this.DataDescriptor.WorstResult, DoubleDiffer) +
+                     GetDiff(example.OutputBoolean, interpreter.BooleanStack, this.DataDescriptor.WorstResult, BooleanDiffer);
 
           results.Add(diff);
@@ -466,11 +466,11 @@
     }
 
-    public void Load(Data data) {
-      Data = data;
-      BestKnownQuality = data.BestResult;
+    public void Load(IBenchmarkSuiteDataDescriptor descriptor) {
+      this.DataDescriptor = descriptor;
+      BestKnownQuality = descriptor.BestResult;
 
       DataBounds[0, 0] = 0;
-      DataBounds[0, 2] = Data.OriginalTrainingCount + Data.OriginalTestCount;
-      DataBounds[0, 1] = Data.OriginalTrainingCount;
+      DataBounds[0, 2] = this.DataDescriptor.OriginalTrainingCount + this.DataDescriptor.OriginalTestCount;
+      DataBounds[0, 1] = this.DataDescriptor.OriginalTrainingCount;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 14744)
@@ -1,31 +1,36 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem {
-  using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.BenchmarkSuite;
   using HeuristicLab.Common;
   using HeuristicLab.Core;
+  using HeuristicLab.Encodings.IntegerVectorEncoding;
+  using HeuristicLab.Optimization;
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
 
   [StorableClass]
   public class PushSolution : NamedItem {
+    [Storable]
     public readonly double Quality;
-    public readonly PushProgram Program;
-    public readonly Data Data;
+    [Storable]
+    public readonly IntegerVector IntegerVector;
+    [Storable]
+    public readonly IBenchmarkSuiteDataDescriptor DataDescriptor;
+    [Storable]
     public readonly IRandom Random;
-    public readonly PushInterpreterPool Pool;
+    [Storable]
+    public readonly IReadonlyPushConfiguration Config;
 
-    public PushSolution(PushProgram program, double quality, Data data,
-      IRandom random, PushInterpreterPool pool)
+    public PushSolution(IntegerVector integerVector, double quality, IBenchmarkSuiteDataDescriptor dataDescriptor, IRandom random, IReadonlyPushConfiguration config)
       : base("Solution", "A push solution.") {
-      Program = program;
+      IntegerVector = integerVector;
       Quality = quality;
-      Data = data;
+      DataDescriptor = dataDescriptor;
       Random = random;
-      Pool = pool;
+      Config = config;
     }
 
     public PushSolution(PushSolution origin, Cloner cloner) : base(origin, cloner) {
-      Program = origin.Program;
+      IntegerVector = origin.IntegerVector;
       Quality = origin.Quality;
     }
